"""s_miner.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming wielding a mighty pickaxe.
"""

from excepts import *


# -1/1 are the l/r animation frames, -2/2 are the l/r subtraction masks
attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": True, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None], -2:[[],None], 2:[[],None]}


def update(lemming):
    try:
        if lemming.direction == -1:
            bound = lemming.rect.left
            block = "rightArrows"
        else:
            bound = lemming.rect.right
            block = "leftArrows"
        for i in range(lemming.rect.centerx, bound, lemming.direction):
            if lemming.checkPos((i, lemming.posY), "steel") or lemming.checkPos((i, lemming.posY), block):
                lemming.setSkill("s_walker")
                return
        for i in range(lemming.rect.top, lemming.rect.bottom):
            if lemming.checkPos((bound, i), "steel") or lemming.checkPos((bound, i), block):
                lemming.setSkill("s_walker")
                return
    except OutOfThePlayfield:
        pass


    if lemming.currentFrame == 1:
        lemming.posX += lemming.direction
        lemming.rect.midbottom = (lemming.posX, lemming.posY+1)
        lemming.game.subtract(frames[lemming.direction*2][0][0], (lemming.rect.left-lemming.direction, lemming.rect.top)) 
    elif lemming.currentFrame == 2:
        lemming.posX += lemming.direction
        lemming.posY += 1
        lemming.rect.midbottom = (lemming.posX, lemming.posY+1)
        lemming.game.subtract(frames[lemming.direction*2][0][1], (lemming.rect.left-lemming.direction, lemming.rect.top))
    elif lemming.currentFrame == 15:
        lemming.posX += lemming.direction*2
    elif lemming.currentFrame >= lemming.frameCount:
        lemming.currentFrame = 0
        lemming.posY += 1

    lemming._incAnimFrame()

    try:
        if not lemming.checkPos((lemming.posX, lemming.posY+1), "ground") and not lemming.checkPos((lemming.posX, lemming.posY), "ground"):
            lemming.setSkill("s_faller")
            return
    except OutOfThePlayfield:
        lemming.kill()

    return

def set(lemming):
    lemming.currentSkill = "s_miner"
    lemming.currentFrame = 0
    lemming.posY += 1
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
    
