"""s_shrugger.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains what happens when a lemming finds building too hard, and just throws in the towel.
"""

from excepts import *

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

def update(lemming):
    if lemming.currentFrame == lemming.frameCount:
        lemming.setSkill("s_walker")
    elif not lemming.checkPos((lemming.posX, lemming.posY+1), "ground"):
        lemming.setSkill("s_faller")
    else:
        lemming._incAnimFrame()
    return

def set(lemming):
    lemming.currentSkill = "s_shrugger"
    lemming.currentFrame = 0
    lemming.rect.left = frames[lemming.direction][1].left
    lemming.rect.right = frames[lemming.direction][1].right
    lemming.rect.width = frames[lemming.direction][1].width
    lemming.rect.height = frames[lemming.direction][1].height
    lemming.frameCount = len(frames[lemming.direction][0])
    lemming._incAnimFrame()
    return
